// const csvUrl = 'https://raw.githubusercontent.com/CSSEGISandData/COVID-19/d54477e362a4b39d1070b503268677fa5d74084d/csse_covid_19_data/csse_covid_19_time_series/time_series_covid19_deaths_global.csv';

import React, { useState, useEffect } from 'react';
import { format, csv, timeParse } from 'd3';

const csvUrl =
  'https://raw.githubusercontent.com/CSSEGISandData/COVID-19/master/csse_covid_19_data/csse_covid_19_time_series/time_series_covid19_deaths_global.csv';

const parseDate = timeParse('%-m/%-d/%y');
// const commaFormatter = format(',');
const sum = (acc, curr) => acc + curr;

const transform = (rawData) => {
  const days = rawData.columns.slice(4);
  return days.map((day) => ({
    date: parseDate(day),
    deathTotal: rawData.map((d) => +d[day]).reduce(sum, 0),
  }));
};

export const useData = () => {
  const [data, setData] = useState(null);

  useEffect(() => {
    csv(csvUrl).then((rawData) =>
      setData(transform(rawData))
    );
  }, []);

  return data;
};
